/*  DMX Eingenbau Moving Head V1.0
*
* Last updated	: 10.12.08
* Target		: AtMega32
* Clock			: 8MHz
*
* by Markus Wallschlag
*	
******************************************************************************/

//Prprozessor Anweisungen
#include "pwm.h"
#include "dmx512.h"

#include <avr/io.h>
#include <util/delay.h>

#include "grafik_lcd.h"
#include "small_font.h"
#include "mega.h"
#include "image_load.h"

//****************************************************************************

int pwm_up(int i)
{
	switch (i)
	{
		case 1:
		{
			if (pwm3 < 100)
				break;
			for (pwm3=pwm3;pwm3>=100;pwm3--)
				_delay_ms(40);
			break;
		}

		case 2:
		{
			if (pwm4 < 100)
				break;
			for (pwm4=pwm4;pwm4>=100;pwm4--)
				_delay_ms(40);
			break;
		}
	}
	return 0;
}

int pwm_down(int i)
{
	switch (i)
	{
		case 1:
		{
			if (pwm3 < 100)
				break;
			for (pwm3=pwm3;pwm3>=100;pwm3++)
				_delay_ms(40);
			break;
		}

		case 2:
		{
			if (pwm4 < 100)
				break;
			for (pwm4=pwm4;pwm4>=100;pwm4++)
				_delay_ms(40);
			break;
		}
	}
	return 0;

}



//HAUPTPROGRAMM
int main(void)
{

	/* Initialisierung */
	cli();			//Interrupts aus
	DDRD = (1<<PD2) | (1<<PD3);					
	DDRC = 0xff; //Datenrichtung alle Pins als Ausgnge
	init_DMX();
	lcd_init();
	lcd_clear();

	uint8_t loop;

	// zeichne Eieruhr
	lcd_draw_fullscreen_bmp(img);

	// zeichne Prozessbalken
	lcd_draw_rect(22,23,100,16,BLACK);		
	for(loop=6;loop<=96;loop+=10)
	{
		_delay_ms(40);
		lcd_fill_rect (24,25,loop,12,BLACK);	// fill progressbar
	}		
	for(loop=0;loop<=100;loop++,_delay_ms(40));		//halte Bildschirm



	init_pwm();		//KONFLIKT MIT DISPLAY!!!!!!!
  


	


	
	
		
	
	sei();		//Interrupts an
	

	
	while(1)
	{
		pwm3 =  DmxField[0];
	  	pwm4 =  DmxField[1];

		if (DmxField[2] >= 127)	
			{		
				PORTC &= ~(1<<PC3);		//Richtung 1 Achse 2
				//pwm_down(1);
				PORTC |= (1<<PC4);		
				//pwm_up(1);
			}
		else
			{
				PORTC &= ~(1<<PC4);		//Richtung 2 Achse 2
				//pwm_down(1);
				PORTC |= (1<<PC3);	
				//pwm_up(1);
			}



		if (DmxField[3] >= 127)			
			{
				PORTC &= ~(1<<PC5);		//Richtung 1 Achse 1
				//pwm_down(2);
				PORTC |= (1<<PC6);
				//pwm_up(2);	
			}	
		else
			{
				PORTC &= ~(1<<PC6);		//Richtung 2 Achse 1
				//pwm_down(2);
				PORTC |= (1<<PC5);
				//pwm_up(2);
			}
		

		
	
		if (DmxField[6] >= 127)	//Lampe an/aus
			PORTD |= (1<<PD2);		
		else
			PORTD &= ~(1<<PD2);

		if (DmxField[7] >= 127)	//Nebelpumpe an/aus
			PORTD |= (1<<PD3);
		else
			PORTD &= ~(1<<PD3);
		

	}

	return 0;

}


