/*  DMX Eingenbau Moving Head V1.0
*
* Title			: Pulsweitenmodulation Motorentreiber
* Last updated	: 21.04.07
* Target		: Transceiver Rev.3.01 [AtMega32]
* Clock			: 8MHz, 16MHz

**************************************************************************/
#include "pwm.h"


void init_pwm (void)
{  

  // Timer 1 PWM Init
  TCCR1A =    (1 << COM1A1)
    	   |  (0 << COM1A0)
		   |  (1 << COM1B1)
    	   |  (0 << COM1B0) 	//Fast-PWM: Compare Mode set (non-inverting) A+B
  		   |  (1 << WGM11)  	//--> Waveform Generation Mode: 5
  		   |  (0 << WGM10);
		 
  TCCR1B =    (1 << WGM13)
  		   |  (1 << WGM12)
		   |  (0 << CS12)		//clk/256
		   |  (0 << CS11)
		   |  (1 << CS10);


	unsigned char sreg;
	sreg = SREG;		/* Save global interrupt flag */
	//_CLI();				/* Disable interrupts */	
	ICR1 = TOP;
	SREG = sreg;		/* Restore global interrupt flag */
	//sei();				/* Enable global Interrupts */

  // OC1A PWM Port
  DDRD   = (1<<PD5);
 // PORTD |= (1<<PD5);
  OCR1AL = 0;

  // OC1B PWM Port
  DDRD   = (1<<PD4);
  OCR1BL = 0;
}


